<template>
  <div class="netdoc">
    <h1>{{ $t('system.netdoc') }}</h1>
    Test
    <b-row>
      <b-col>
        <b-card class="shadow-sm p-3" no-body>
          <h3 class="m-0">{{ $tc('system.bcd', 2) }} & {{ $tc('system.vlan', 2) }}</h3>
          <Loading :data="bcds">
            <PaginatorList :items="bcds" initial-items-per-page="25" :sort-function="sort_bcds" block>
              <template v-slot:item="data">
                <b-card class="mb-3 shadow-sm" no-body :key="'bcd-card-'+ data.item.name">
                  <b-card-header v-b-toggle="'bcd-'+data.item.name+'-collapse'" class="collapse-header">
                    <h5 class="d-inline">{{ data.item.name }}</h5>
                    <p v-if="data.item.vlan_count === 0"
                       class="d-inline float-right font-italic mb-0">{{ $t('views.nd.netdoc.no_vlans') }}</p>
                    <netvs-icon v-else class="collapse-icon" icon="collapse"></netvs-icon>
                  </b-card-header>
                  <b-card-body body-class="p-0" v-if="bcd2vlans[data.item.name] && bcd2vlans[data.item.name].length > 0">
                    <b-collapse :id="'bcd-'+data.item.name+'-collapse'" v-model="bcd_collapse_states[data.index]">
                      <ul class="mt-3">
                        <li v-for="vlan in bcd2vlans[data.item.name]" :key="'vlan' + vlan.gpk">
                          <b>{{ $tc('system.vlan', 1) }}</b> {{ vlan.id }} - {{ vlan.name }} ({{ vlan.global_pk }}) [{{ vlan.net_instnc }}]
<!--                          <b-button @click="get_l_ports(vlan)">{{ $t('views.nd.netdoc.get_l_ports') }}</b-button>-->
<!--                          <ul>-->
<!--                            <li v-for="l_port in vlan2lports[vlan.global_pk]" :key="'l_port-' + l_port.global_pk">-->
<!--                              <b>{{ $t('views.nd.netdoc.l_port') }}</b> {{ l_port.name }} ({{ l_port.global_pk }}) | {{ l_port.description || '-' }}-->
<!--                              | {{ l_port.dev_fqdn }}-->
<!--                              <ul>-->
<!--                                <li v-for="l2p_port in vlan2l2pports[vlan.global_pk][l_port.pk]"-->
<!--                                    :key="'l2p_port-' + vlan.global_pk + '-' + l_port.pk + '-' + l2p_port.p_port_pk">-->
<!--                                  <b>{{ $t('views.nd.netdoc.p_port') }}</b> {{ vlan2pports[vlan.global_pk][l2p_port.p_port_pk][0].name }}-->
<!--                                  ({{ vlan2pports[vlan.global_pk][l2p_port.p_port_pk][0].global_pk }}) |-->
<!--                                  {{ vlan2pports[vlan.global_pk][l2p_port.p_port_pk][0].speed }}-->
<!--                                </li>-->
<!--                              </ul>-->
<!--                            </li>-->
<!--                          </ul>-->
                        </li>
                      </ul>
                    </b-collapse>
                  </b-card-body>
                </b-card>
              </template>
            </PaginatorList>
          </Loading>
        </b-card>
      </b-col>
    </b-row>
  </div>
</template>

<script>
import NetdocService from '@/api-services/netdoc.service'
import apiutil from '@/util/apiutil'
import Loading from '@/components/Loading'
import PaginatorList from '@/components/PaginatorList'

export default {
  name: 'NetDoc',
  components: { PaginatorList, Loading },
  data() {
    return {
      bcds: null,
      bcd2vlans: null,
      vlan2lports: {},
      vlan2l2pports: {},
      vlan2pports: {},
      bcd_collapse_states: [],
      network_nodes: [{ id: 0, label: 'Base', shape: 'circle' }],
      network_edges: [],
      network_options: {
        nodes: {
          borderWidth: 4,
          font: {
            color: 'white',
            face: 'arial'
          }
        },
        edges: {
          color: 'lightgray'
        }
      },
      interaction: { hover: true }
    }
  },
  async created() {
    const response = await NetdocService.getVLANs(this.$store.state)
    this.bcds = response.data.bcd_list
    this.bcd2vlans = apiutil.dict_of_lists_by_value_of_array(response.data.vlan_list, 'bcd')
    console.log(this.bcd2vlans)
  },
  methods: {
    async get_l_ports(vlan) {
      const response = await NetdocService.getLports(this.$store.state, vlan)
      this.$set(this.vlan2lports, vlan.global_pk, response.data[2])
      this.$set(this.vlan2l2pports, vlan.global_pk, apiutil.dict_of_lists_by_value_of_array(response.data[3], 'l_port_pk'))
      this.$set(this.vlan2pports, vlan.global_pk, apiutil.dict_of_lists_by_value_of_array(response.data[4], 'pk'))
    },
    sort_bcds(a, b) {
      return (a.vlan_count === b.vlan_count) ? 0 : a.vlan_count ? -1 : 1
    },
    onClicked(e) {
      if (e.nodes.length === 0) return
      const selectedId = e.nodes[0]
      const newId = this.network_nodes.length
      this.network_nodes.push({ id: newId, label: 'Base', shape: 'circle' })
      this.network_edges.push({ from: selectedId, to: newId })
      window.console.log(newId)
    },
    onNodeSelected(e) {
      const selectedId = e.nodes[0]
      const newId = this.network_nodes.length
      this.network_nodes.push({ id: newId, label: 'Base', shape: 'circle' })
      this.network_edges.push({ from: selectedId, to: newId })
      window.console.log(newId)
    },
    onNodeHovered(e) {
      const selectedId = e.node
      const newId = this.network_nodes.length
      this.network_nodes.push({ id: newId, label: 'Base', shape: 'circle' })
      this.network_edges.push({ from: selectedId, to: newId })
      window.console.log(newId)
    },
    onDragStarted(e) {
      window.console.log(e)
    }
  }
}
</script>

<style scoped>
.collapse-icon {
  display: inline;
  vertical-align: center;
  float: right;

  transition: transform;
  transition-duration: 250ms;
}

.not-collapsed > .collapse-icon {
  transform: rotate(-180deg);
}

.collapse-header {
  z-index: 69;
}

.network-card {
  height: 75vh;
}

#network {
  width: 100%;
  height: 100%;
}
</style>
